
%% load matrix;
load can_mod;
n = size(A,1);
figure(1);
%% original;
spy(A) ;
fprintf(1,' original     nnz = %d \n',nnz(A))
pause(2) ;
%% NOTE: LUFACTOR FOR DEMOS ONLY (VERY
%% INEFFICIENT) - USE lu(..) for real computations.!
[L, U] = lufactor(A);
figure(2) ;
spy(L+U)
pause(2) ;
n1 = nnz(L)+nnz(U)-n;
fprintf(1,' original LU fill = %d \n',n1)
%% reverse cuthill-Mc Kee
p = symrcm(A);
%% straight cuthill-Mc Kee
q = p(n:-1:1);
B = A(q,q);
figure(3) 
spy(B);
pause(2) ;
[L, U] = lufactor(B);
figure(4) 
spy(L+U);
n2 = nnz(L)+nnz(U)-n;
fprintf(1,' C M         fill = %d \n',n2)
%% reverse cuthill-Mc Kee
C = A(p,p);
figure(5) 
spy(B);
pause(2) ;
[L, U] = lufactor(C);
figure(6) 
spy(L+U);
pause(2) ;
n3 = nnz(L)+nnz(U)-n;
fprintf(1,' Reverse C M fill = %d \n',n3)


