 function x = precLDU(PRE, rhs) 
%% function rhs = precLDU(PRE, rhs) 
%% arms preconditioning operation
%% PRE = struct for preconditioner
%%-------------------------------------------------

L = PRE.L;
D = PRE.D;
U = PRE.U; 
kiter = PRE.kiter;
%%%x = U \ ( D .* (L \ rhs)) ;
%% not coded efficiently... would need to pass a few 
%% more things/./
%% 1st iteration. Corresponds to taking x_0 == 0.
x = L \ rhs;
%% ssor: uncomment the following 
%%  x = U \ (rhs - L*x + x ./ D);
for k = 2:kiter 
    x =  L \ (rhs - U*x + x .* D);
%% ssor : uncomment the following 
%%  x =  U \ (rhs - L*x + x .* D);
end
