 function [L,U] = lufactor (A) 
%---------------------------------------------
%  function [L,U] = lufactor (A) 
%  performs LU factorization of a matrix A 
%---------------------------------------------
 n = size(A,1) ;
 U = A; L = eye(n,n) ;
 for k=1:n-1 
     for i=k+1:n
     piv =  U(i,k) / U(k,k) ;
     L(i,k) = piv; 
     U(i,k:n) = U(i,k:n) - piv*U(k,k:n);
   end
 end 
