function [x,nrmHist] = steep(A, b, x, nsteps) 
% steepest descent 
% function [x,r] = steep(A, x, b, nsteps) 
% A = matrix = 
% x = initial guess on entry -- app sol on return 
% b = rhs, 
% nsteps = number of steps --
 r = b - A * x;
 nrmHist(1) = norm(r); 
%%
 for i=1:nsteps
	 ar = A * r; 
	 alp = r'*r / ( r' * ar);
	 x = x + alp * r;
	 r = r - alp* ar;
%%  save norms for plotting
         nrmHist(i+1) = norm(r);  
 end 
          
